// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef MEMORY_INST_HH
#define MEMORY_INST_HH

#include <cstddef>
#include <stdint.h>

class memory_inst
{

public:

    uint32_t prdata_old;
    bool pready_old;
    bool oeb_old;
    bool we_n_old;
    bool sync_old;
    bool vpab_old;
    uint8_t datao_old;
    uint16_t addr_old;
    bool rst_old;
    bool clk_old;
    struct memory_inst_iostruct{
        bool * clk;
        bool * rst;
        uint16_t * addr;
        uint8_t * datai;
        uint8_t * datao;
        bool * irq_n;
        bool * nmi_n;
        bool * sob_n;
        bool * res_n;
        bool * rdy;
        bool * vpab;
        bool * sync;
        bool * we_n;
        bool * oeb;
        bool * psel1;
        bool * psel2;
        bool * psel3;
        bool * psel4;
        bool * psel5;
        bool * psel6;
        bool * psel7;
        bool * psel8;
        bool * penable;
        bool * presetn;
        uint32_t * paddr;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;

        memory_inst_iostruct():
            clk(nullptr),
            rst(nullptr),
            addr(nullptr),
            datai(nullptr),
            datao(nullptr),
            irq_n(nullptr),
            nmi_n(nullptr),
            sob_n(nullptr),
            res_n(nullptr),
            rdy(nullptr),
            vpab(nullptr),
            sync(nullptr),
            we_n(nullptr),
            oeb(nullptr),
            psel1(nullptr),
            psel2(nullptr),
            psel3(nullptr),
            psel4(nullptr),
            psel5(nullptr),
            psel6(nullptr),
            psel7(nullptr),
            psel8(nullptr),
            penable(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr)
        {}

        memory_inst_iostruct( bool * clk_4, bool * rst_0, uint16_t * addr_1, uint8_t
             * datai_1, uint8_t * datao_1, bool * irq_n_1, bool * nmi_n_1, bool
             * sob_n_1, bool * res_n_1, bool * rdy_1, bool * vpab_1, bool * sync_1,
             bool * we_n_1, bool * oeb_1, bool * psel1_0, bool * psel2_0, bool *
             psel3_0, bool * psel4_0, bool * psel5_0, bool * psel6_0, bool * psel7_0,
             bool * psel8_0, bool * penable_7, bool * presetn_7, uint32_t * paddr_7,
             bool * pwrite_7, uint32_t * pwdata_7, bool * pready_7, uint32_t * prdata_7
             ):
            clk(clk_4),
            rst(rst_0),
            addr(addr_1),
            datai(datai_1),
            datao(datao_1),
            irq_n(irq_n_1),
            nmi_n(nmi_n_1),
            sob_n(sob_n_1),
            res_n(res_n_1),
            rdy(rdy_1),
            vpab(vpab_1),
            sync(sync_1),
            we_n(we_n_1),
            oeb(oeb_1),
            psel1(psel1_0),
            psel2(psel2_0),
            psel3(psel3_0),
            psel4(psel4_0),
            psel5(psel5_0),
            psel6(psel6_0),
            psel7(psel7_0),
            psel8(psel8_0),
            penable(penable_7),
            presetn(presetn_7),
            paddr(paddr_7),
            pwrite(pwrite_7),
            pwdata(pwdata_7),
            pready(pready_7),
            prdata(prdata_7)
        {}

        ~memory_inst_iostruct()
        {}

        bool operator == (const memory_inst_iostruct & other) const
        {
            if (clk != other.clk) return false;
            if (rst != other.rst) return false;
            if (addr != other.addr) return false;
            if (datai != other.datai) return false;
            if (datao != other.datao) return false;
            if (irq_n != other.irq_n) return false;
            if (nmi_n != other.nmi_n) return false;
            if (sob_n != other.sob_n) return false;
            if (res_n != other.res_n) return false;
            if (rdy != other.rdy) return false;
            if (vpab != other.vpab) return false;
            if (sync != other.sync) return false;
            if (we_n != other.we_n) return false;
            if (oeb != other.oeb) return false;
            if (psel1 != other.psel1) return false;
            if (psel2 != other.psel2) return false;
            if (psel3 != other.psel3) return false;
            if (psel4 != other.psel4) return false;
            if (psel5 != other.psel5) return false;
            if (psel6 != other.psel6) return false;
            if (psel7 != other.psel7) return false;
            if (psel8 != other.psel8) return false;
            if (penable != other.penable) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            return true;
        }
    };
    memory_inst_iostruct hif_a2t_data;
    uint32_t pwdata_var;
    uint32_t paddr_var;
    uint8_t state;
    uint8_t state_sig_var;
    uint8_t _ram[32768L];
    uint8_t _rom[16384L];
    uint16_t ram_addr;
    uint16_t rom_addr;
    bool addr_firstbit_ram;
    bool addr_firstbit_rom;
    memory_inst();


    ~memory_inst();


    uint8_t state_new;
    bool process_in_queue;
    bool flag_initial_process_executed;
    bool flag_state;
    bool flag_clk;
    bool flag_addr;
    bool flag_process_0_process_2_executed;
    bool flag_pos_clk;

    void initial_process();


    void process();


    void process_1();


    void process_0_process_2();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    memory_inst( const memory_inst & );
    const memory_inst& operator= ( const memory_inst & );


};


#endif

